'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var PropTypes = require('prop-types');
var EventEmitter = require('events');
var cs = require('classnames');

function _interopDefault (e) { return e && e.__esModule ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefault(React);
var PropTypes__default = /*#__PURE__*/_interopDefault(PropTypes);
var EventEmitter__default = /*#__PURE__*/_interopDefault(EventEmitter);
var cs__default = /*#__PURE__*/_interopDefault(cs);

function _toPrimitive(input, hint) {
  if (typeof input !== "object" || input === null) return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== undefined) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object") return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}

function _toPropertyKey(arg) {
  var key = _toPrimitive(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}

function _defineProperty(obj, key, value) {
  key = _toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }
  return keys;
}
function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}

var Const = {
  PAGINATION_SIZE: 5,
  PAGE_START_INDEX: 1,
  With_FIRST_AND_LAST: true,
  SHOW_ALL_PAGE_BTNS: false,
  SHOW_TOTAL: false,
  PAGINATION_TOTAL: null,
  FIRST_PAGE_TEXT: '<<',
  PRE_PAGE_TEXT: '<',
  NEXT_PAGE_TEXT: '>',
  LAST_PAGE_TEXT: '>>',
  NEXT_PAGE_TITLE: 'next page',
  LAST_PAGE_TITLE: 'last page',
  PRE_PAGE_TITLE: 'previous page',
  FIRST_PAGE_TITLE: 'first page',
  SIZE_PER_PAGE_LIST: [10, 25, 30, 50],
  HIDE_SIZE_PER_PAGE: false,
  HIDE_PAGE_LIST_ONLY_ONE_PAGE: false
};

const getNormalizedPage = (page, pageStartIndex) => {
  const offset = Math.abs(1 - pageStartIndex);
  return page + offset;
};
const endIndex = (page, sizePerPage, pageStartIndex) => getNormalizedPage(page, pageStartIndex) * sizePerPage - 1;
const startIndex = (end, sizePerPage) => end - (sizePerPage - 1);
const alignPage = (dataSize, prevDataSize, page, sizePerPage, pageStartIndex) => {
  if (prevDataSize < dataSize) return page;
  if (page < pageStartIndex) return pageStartIndex;
  if (dataSize <= 0) return pageStartIndex;
  if (page >= Math.floor(dataSize / sizePerPage) + pageStartIndex && pageStartIndex === 1) {
    return Math.ceil(dataSize / sizePerPage);
  }
  if (page >= Math.floor(dataSize / sizePerPage) && pageStartIndex === 0) {
    const newPage = Math.ceil(dataSize / sizePerPage);
    return newPage - Math.abs(Const.PAGE_START_INDEX - pageStartIndex);
  }
  return page;
};
const getByCurrPage = (data, page, sizePerPage, pageStartIndex) => {
  const dataSize = data.length;
  if (!dataSize) return [];
  const end = endIndex(page, sizePerPage, pageStartIndex);
  const start = startIndex(end, sizePerPage);
  const result = [];
  for (let i = start; i <= end; i += 1) {
    result.push(data[i]);
    if (i + 1 === dataSize) break;
  }
  return result;
};

const StateContext = /*#__PURE__*/React__default["default"].createContext();

// function updateStateFromProps(props) {
//   let currPage;
//   let currSizePerPage;
//   const { options } = props.pagination;
//   const sizePerPageList = options.sizePerPageList || Const.SIZE_PER_PAGE_LIST;

//   // initialize current page
//   if (typeof options.page !== 'undefined') {
//     currPage = options.page;
//   } else if (typeof options.pageStartIndex !== 'undefined') {
//     currPage = options.pageStartIndex;
//   } else {
//     currPage = Const.PAGE_START_INDEX;
//   }

//   // initialize current sizePerPage
//   if (typeof options.sizePerPage !== 'undefined') {
//     currSizePerPage = options.sizePerPage;
//   } else if (typeof sizePerPageList[0] === 'object') {
//     currSizePerPage = sizePerPageList[0].value;
//   } else {
//     const [currSizePerPageList] = sizePerPageList;
//     currSizePerPage = currSizePerPageList;
//   }

//   return {
//     currPage,
//     dataSize: options.totalSize,
//     currSizePerPage
//   };
// }

class StateProvider extends React__default["default"].Component {
  constructor(props) {
    super(props);
    // this.handleChangePage = this.handleChangePage.bind(this);
    // this.handleDataSizeChange = this.handleDataSizeChange.bind(this);
    // this.handleChangeSizePerPage = this.handleChangeSizePerPage.bind(this);
    this.handleDataSizeChange = newDataSize => {
      const {
        pagination: {
          options
        }
      } = this.props;
      // this.setState(({ dataSize, currPage, currSizePerPage }) => {
      //   const pageStartIndex = typeof options.pageStartIndex === 'undefined'
      //     ? Const.PAGE_START_INDEX : options.pageStartIndex;
      //   return {
      //     currPage: alignPage(
      //       newDataSize,
      //       dataSize,
      //       currPage,
      //       currSizePerPage,
      //       pageStartIndex
      //     ),
      //     dataSize: newDataSize
      //   };
      // }, () => {
      //   this.forceUpdate();
      // });
      // const { dataSize, currPage, currSizePerPage } = this.state;
      // const { dataSize, currPage, currSizePerPage } = this;
      const pageStartIndex = typeof options.pageStartIndex === 'undefined' ? Const.PAGE_START_INDEX : options.pageStartIndex;
      this.currPage = alignPage(newDataSize, this.dataSize, this.currPage, this.currSizePerPage, pageStartIndex);
      this.dataSize = newDataSize;
      this.forceUpdate();
    };
    this.handleChangePage = currPage => {
      const {
        currSizePerPage
      } = this;
      // const { currSizePerPage } = this.state;
      const {
        pagination: {
          options
        }
      } = this.props;
      if (options.onPageChange) {
        options.onPageChange(currPage, currSizePerPage);
      }
      this.currPage = currPage;
      // this.setState({ currPage }, () => {
      //   // eslint-disable-next-line no-shadow
      //   const { currPage, currSizePerPage } = this.state;
      //   if (this.isRemotePagination()) {
      //     this.paginationRemoteEmitter.emit('paginationChange', currPage, currSizePerPage);
      //     return;
      //   }
      //   this.forceUpdate();
      // });

      if (this.isRemotePagination()) {
        this.paginationRemoteEmitter.emit('paginationChange', currPage, currSizePerPage);
        return;
      }
      this.forceUpdate();
    };
    this.handleChangeSizePerPage = (currSizePerPage, currPage) => {
      const {
        pagination: {
          options
        }
      } = this.props;
      if (options.onSizePerPageChange) {
        options.onSizePerPageChange(currSizePerPage, currPage);
      }
      this.currPage = currPage;
      this.currSizePerPage = currSizePerPage;
      // this.setState({ currPage, currSizePerPage }, () => {
      //   // eslint-disable-next-line no-shadow
      //   const { currPage, currSizePerPage } = this.state;
      //   if (this.isRemotePagination()) {
      //     this.paginationRemoteEmitter.emit('paginationChange', currPage, currSizePerPage);
      //     return;
      //   }
      //   this.forceUpdate();
      // });

      if (this.isRemotePagination()) {
        this.paginationRemoteEmitter.emit('paginationChange', currPage, currSizePerPage);
        return;
      }
      this.forceUpdate();
    };
    this.getPaginationProps = () => {
      const {
        pagination: {
          options
        },
        bootstrap4,
        tableId
      } = this.props;
      // const { currPage, currSizePerPage, dataSize } = this.state;
      const {
        currPage,
        currSizePerPage,
        dataSize
      } = this;
      const withFirstAndLast = typeof options.withFirstAndLast === 'undefined' ? Const.With_FIRST_AND_LAST : options.withFirstAndLast;
      const alwaysShowAllBtns = typeof options.alwaysShowAllBtns === 'undefined' ? Const.SHOW_ALL_PAGE_BTNS : options.alwaysShowAllBtns;
      const hideSizePerPage = typeof options.hideSizePerPage === 'undefined' ? Const.HIDE_SIZE_PER_PAGE : options.hideSizePerPage;
      const hidePageListOnlyOnePage = typeof options.hidePageListOnlyOnePage === 'undefined' ? Const.HIDE_PAGE_LIST_ONLY_ONE_PAGE : options.hidePageListOnlyOnePage;
      const pageStartIndex = typeof options.pageStartIndex === 'undefined' ? Const.PAGE_START_INDEX : options.pageStartIndex;
      return _objectSpread2(_objectSpread2({}, options), {}, {
        bootstrap4,
        tableId,
        page: currPage,
        sizePerPage: currSizePerPage,
        pageStartIndex,
        hidePageListOnlyOnePage,
        hideSizePerPage,
        alwaysShowAllBtns,
        withFirstAndLast,
        dataSize,
        sizePerPageList: options.sizePerPageList || Const.SIZE_PER_PAGE_LIST,
        paginationSize: options.paginationSize || Const.PAGINATION_SIZE,
        showTotal: options.showTotal,
        pageListRenderer: options.pageListRenderer,
        pageButtonRenderer: options.pageButtonRenderer,
        sizePerPageRenderer: options.sizePerPageRenderer,
        paginationTotalRenderer: options.paginationTotalRenderer,
        sizePerPageOptionRenderer: options.sizePerPageOptionRenderer,
        firstPageText: options.firstPageText || Const.FIRST_PAGE_TEXT,
        prePageText: options.prePageText || Const.PRE_PAGE_TEXT,
        nextPageText: options.nextPageText || Const.NEXT_PAGE_TEXT,
        lastPageText: options.lastPageText || Const.LAST_PAGE_TEXT,
        prePageTitle: options.prePageTitle || Const.PRE_PAGE_TITLE,
        nextPageTitle: options.nextPageTitle || Const.NEXT_PAGE_TITLE,
        firstPageTitle: options.firstPageTitle || Const.FIRST_PAGE_TITLE,
        lastPageTitle: options.lastPageTitle || Const.LAST_PAGE_TITLE,
        onPageChange: this.handleChangePage,
        onSizePerPageChange: this.handleChangeSizePerPage
      });
    };
    this.isRemotePagination = () => {
      const e = {};
      this.remoteEmitter.emit('isRemotePagination', e);
      return e.result;
    };
    this.setPaginationRemoteEmitter = remoteEmitter => {
      this.remoteEmitter = remoteEmitter;
    };
    let _currPage;
    let _currSizePerPage;
    const {
      options: _options
    } = props.pagination;
    const sizePerPageList = _options.sizePerPageList || Const.SIZE_PER_PAGE_LIST;

    // initialize current page
    if (typeof _options.page !== 'undefined') {
      _currPage = _options.page;
    } else if (typeof _options.pageStartIndex !== 'undefined') {
      _currPage = _options.pageStartIndex;
    } else {
      _currPage = Const.PAGE_START_INDEX;
    }

    // initialize current sizePerPage
    if (typeof _options.sizePerPage !== 'undefined') {
      _currSizePerPage = _options.sizePerPage;
    } else if (typeof sizePerPageList[0] === 'object') {
      _currSizePerPage = sizePerPageList[0].value;
    } else {
      const [currSizePerPageList] = sizePerPageList;
      _currSizePerPage = currSizePerPageList;
    }
    this.currPage = _currPage;
    this.dataSize = _options.totalSize;
    this.currSizePerPage = _currSizePerPage;
    // this.state = updateStateFromProps(props);
    this.dataChangeListener = new EventEmitter__default["default"]();
    this.dataChangeListener.on('filterChanged', this.handleDataSizeChange);
  }

  // componentDidUpdate() {
  //   const { custom } = this.props?.pagination?.options ?? { custom: false };

  //   // user should align the page when the page is not fit to the data size when remote enable
  //   if (this.isRemotePagination() || custom) {
  //     if (typeof this.props.pagination.options.page !== 'undefined') {
  //       this.currPage = this.props.pagination.options.page;
  //     }
  //     if (typeof this.props.pagination.options.sizePerPage !== 'undefined') {
  //       this.currSizePerPage = this.props.pagination.options.sizePerPage;
  //     }
  //     if (typeof this.props.pagination.options.totalSize !== 'undefined') {
  //       this.dataSize = this.props.pagination.options.totalSize;
  //     }
  //     // if (this.props?.pagination?.options?.page !== prevProps?.pagination?.options?.page) {
  //     //   this.setState({ currPage: this.props.pagination.options.page });
  //     // }
  //     // if (this.props?.pagination?.options?.sizePerPage !== prevProps?.pagination?.options?.sizePerPage) {
  //     //   this.setState({ currSizePerPage: this.props.pagination.options.sizePerPage });
  //     // }
  //     // if (this.props?.pagination?.options?.totalSize !== prevProps?.pagination?.options?.totalSize) {
  //     //   this.setState({ dataSize: this.props.pagination.options.totalSize });
  //     // }
  //   }
  // }

  UNSAFE_componentWillReceiveProps(nextProps) {
    var _nextProps$pagination, _nextProps$pagination2;
    const {
      custom
    } = (_nextProps$pagination = nextProps === null || nextProps === void 0 ? void 0 : (_nextProps$pagination2 = nextProps.pagination) === null || _nextProps$pagination2 === void 0 ? void 0 : _nextProps$pagination2.options) !== null && _nextProps$pagination !== void 0 ? _nextProps$pagination : {
      custom: false
    };

    // user should align the page when the page is not fit to the data size when remote enable
    if (this.isRemotePagination() || custom) {
      if (typeof nextProps.pagination.options.page !== 'undefined') {
        this.currPage = nextProps.pagination.options.page;
      }
      if (typeof nextProps.pagination.options.sizePerPage !== 'undefined') {
        this.currSizePerPage = nextProps.pagination.options.sizePerPage;
      }
      if (typeof nextProps.pagination.options.totalSize !== 'undefined') {
        this.dataSize = nextProps.pagination.options.totalSize;
      }
      // if (nextProps?.pagination?.options?.page !== prevProps?.pagination?.options?.page) {
      //   this.setState({ currPage: nextProps.pagination.options.page });
      // }
      // if (nextProps?.pagination?.options?.sizePerPage !== prevProps?.pagination?.options?.sizePerPage) {
      //   this.setState({ currSizePerPage: nextProps.pagination.options.sizePerPage });
      // }
      // if (nextProps?.pagination?.options?.totalSize !== prevProps?.pagination?.options?.totalSize) {
      //   this.setState({ dataSize: nextProps.pagination.options.totalSize });
      // }
    }
  }

  get paginationRemoteEmitter() {
    const {
      remoteEmitter
    } = this.props;
    return this.remoteEmitter || remoteEmitter;
  }
  render() {
    const paginationProps = this.getPaginationProps();
    const pagination = _objectSpread2(_objectSpread2({}, this.props.pagination), {}, {
      options: paginationProps
    });
    return /*#__PURE__*/React__default["default"].createElement(StateContext.Provider, {
      value: {
        paginationProps,
        paginationTableProps: {
          pagination,
          setPaginationRemoteEmitter: this.setPaginationRemoteEmitter,
          dataChangeListener: this.dataChangeListener
        }
      }
    }, this.props.children);
  }
}
var createBaseContext = (() => ({
  Provider: StateProvider,
  Consumer: StateContext.Consumer
}));

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}

/* eslint-disable max-len */
var pageResolver = (ExtendBase => class PageResolver extends ExtendBase {
  constructor(...args) {
    super(...args);
    this.backToPrevPage = () => {
      const {
        currPage,
        pageStartIndex
      } = this.props;
      return currPage - 1 < pageStartIndex ? pageStartIndex : currPage - 1;
    };
    this.calculateTotalPage = (sizePerPage = this.props.currSizePerPage, dataSize = this.props.dataSize) => Math.ceil(dataSize / sizePerPage);
    // const { pageStartIndex } = this.props;
    this.calculateLastPage = (totalPages, pageStartIndex = this.props.pageStartIndex) => pageStartIndex + totalPages - 1;
    this.calculateFromTo = () => {
      const {
        dataSize,
        currPage,
        currSizePerPage,
        pageStartIndex
      } = this.props;
      const offset = Math.abs(Const.PAGE_START_INDEX - pageStartIndex);
      let from = (currPage - pageStartIndex) * currSizePerPage;
      from = dataSize === 0 ? 0 : from + 1;
      let to = Math.min(currSizePerPage * (currPage + offset), dataSize);
      if (to > dataSize) to = dataSize;
      return [from, to];
    };
    this.calculatePages = (totalPages, lastPage) => {
      const {
        currPage,
        paginationSize,
        pageStartIndex,
        withFirstAndLast,
        firstPageText,
        prePageText,
        nextPageText,
        lastPageText,
        alwaysShowAllBtns
      } = this.props;
      let pages = [];
      let endPage = totalPages;
      if (endPage <= 0) return [];
      let startPage = Math.max(currPage - Math.floor(paginationSize / 2), pageStartIndex);
      endPage = startPage + paginationSize - 1;
      if (endPage > lastPage) {
        endPage = lastPage;
        startPage = endPage - paginationSize + 1;
      }
      if (alwaysShowAllBtns) {
        if (withFirstAndLast) {
          pages = [firstPageText, prePageText];
        } else {
          pages = [prePageText];
        }
      }
      if (startPage !== pageStartIndex && totalPages > paginationSize && withFirstAndLast && pages.length === 0) {
        pages = [firstPageText, prePageText];
      } else if (totalPages > 1 && pages.length === 0) {
        pages = [prePageText];
      }
      for (let i = startPage; i <= endPage; i += 1) {
        if (i >= pageStartIndex) pages.push(i);
      }
      if (alwaysShowAllBtns || endPage <= lastPage && pages.length > 1) {
        pages.push(nextPageText);
      }
      if (endPage !== lastPage && withFirstAndLast || withFirstAndLast && alwaysShowAllBtns) {
        pages.push(lastPageText);
      }

      // if ((endPage <= lastPage && pages.length > 1) || alwaysShowAllBtns) {
      //   pages.push(nextPageText);
      // }
      // if (endPage !== lastPage && withFirstAndLast) {
      //   pages.push(lastPageText);
      // }

      return pages;
    };
    this.calculatePageStatus = (pages = [], lastPage, disablePageTitle = false) => {
      const {
        currPage,
        pageStartIndex,
        firstPageText,
        prePageText,
        nextPageText,
        lastPageText,
        alwaysShowAllBtns
      } = this.props;
      const isStart = page => currPage === pageStartIndex && (page === firstPageText || page === prePageText);
      const isEnd = page => currPage === lastPage && (page === nextPageText || page === lastPageText);
      return pages.filter(page => {
        if (alwaysShowAllBtns) {
          return true;
        }
        return !(isStart(page) || isEnd(page));
      }).map(page => {
        let title;
        const active = page === currPage;
        const disabled = isStart(page) || isEnd(page);
        if (page === nextPageText) {
          title = this.props.nextPageTitle;
        } else if (page === prePageText) {
          title = this.props.prePageTitle;
        } else if (page === firstPageText) {
          title = this.props.firstPageTitle;
        } else if (page === lastPageText) {
          title = this.props.lastPageTitle;
        } else {
          title = `${page}`;
        }
        const pageResult = {
          page,
          active,
          disabled
        };
        if (!disablePageTitle) {
          pageResult.title = title;
        }
        return pageResult;
      });
    };
    this.calculateSizePerPageStatus = () => {
      const {
        sizePerPageList
      } = this.props;
      return sizePerPageList.map(_sizePerPage => {
        const pageText = typeof _sizePerPage.text !== 'undefined' ? _sizePerPage.text : _sizePerPage;
        const pageNumber = typeof _sizePerPage.value !== 'undefined' ? _sizePerPage.value : _sizePerPage;
        return {
          text: `${pageText}`,
          page: pageNumber
        };
      });
    };
  }
  initialState() {
    const totalPages = this.calculateTotalPage();
    const lastPage = this.calculateLastPage(totalPages);
    return {
      totalPages,
      lastPage
    };
  }
});

var paginationHandler = (WrappedComponent => class PaginationHandler extends pageResolver(React.Component) {
  constructor(...args) {
    super(...args);
    this.state = this.initialState();
    this.handleChangeSizePerPage = sizePerPage => {
      const {
        currSizePerPage,
        onSizePerPageChange
      } = this.props;
      const selectedSize = typeof sizePerPage === 'string' ? parseInt(sizePerPage, 10) : sizePerPage;
      let {
        currPage
      } = this.props;
      if (selectedSize !== currSizePerPage) {
        const newTotalPages = this.calculateTotalPage(selectedSize);
        const newLastPage = this.calculateLastPage(newTotalPages);
        if (currPage > newLastPage) currPage = newLastPage;
        onSizePerPageChange(selectedSize, currPage);
      }
    };
    this.handleChangePage = newPage => {
      let page;
      const {
        currPage,
        pageStartIndex,
        prePageText,
        nextPageText,
        lastPageText,
        firstPageText,
        onPageChange
      } = this.props;
      const {
        lastPage
      } = this.state;
      if (newPage === prePageText) {
        page = this.backToPrevPage();
      } else if (newPage === nextPageText) {
        page = currPage + 1 > lastPage ? lastPage : currPage + 1;
      } else if (newPage === lastPageText) {
        page = lastPage;
      } else if (newPage === firstPageText) {
        page = pageStartIndex;
      } else {
        page = parseInt(newPage, 10);
      }
      if (page !== currPage) {
        onPageChange(page);
      }
    };
  }
  componentDidUpdate(prevProps) {
    var _this$props, _this$props2;
    const {
      dataSize,
      currSizePerPage
    } = this.props;
    // eslint-disable-next-line max-len
    if (((_this$props = this.props) === null || _this$props === void 0 ? void 0 : _this$props.currSizePerPage) !== (prevProps === null || prevProps === void 0 ? void 0 : prevProps.currSizePerPage) || ((_this$props2 = this.props) === null || _this$props2 === void 0 ? void 0 : _this$props2.dataSize) !== (prevProps === null || prevProps === void 0 ? void 0 : prevProps.dataSize)) {
      const totalPages = this.calculateTotalPage(currSizePerPage, dataSize);
      const lastPage = this.calculateLastPage(totalPages);
      // eslint-disable-next-line react/no-did-update-set-state
      this.setState({
        totalPages,
        lastPage
      });
    }
  }
  render() {
    return /*#__PURE__*/React__default["default"].createElement(WrappedComponent, _extends({}, this.props, {
      lastPage: this.state.lastPage,
      totalPages: this.state.totalPages,
      onPageChange: this.handleChangePage,
      onSizePerPageChange: this.handleChangeSizePerPage
    }));
  }
});

/* eslint-disable jsx-a11y/anchor-is-valid */
const SizePerPageOption = ({
  text,
  page,
  onSizePerPageChange,
  bootstrap4
}) => bootstrap4 ? /*#__PURE__*/React__default["default"].createElement("a", {
  href: "#",
  tabIndex: "-1",
  role: "menuitem",
  className: "dropdown-item",
  "data-page": page,
  onMouseDown: e => {
    e.preventDefault();
    onSizePerPageChange(page);
  }
}, text) : /*#__PURE__*/React__default["default"].createElement("li", {
  key: text,
  role: "presentation",
  className: "dropdown-item"
}, /*#__PURE__*/React__default["default"].createElement("a", {
  href: "#",
  tabIndex: "-1",
  role: "menuitem",
  "data-page": page,
  onMouseDown: e => {
    e.preventDefault();
    onSizePerPageChange(page);
  }
}, text));
SizePerPageOption.propTypes = {
  text: PropTypes__default["default"].string.isRequired,
  page: PropTypes__default["default"].number.isRequired,
  onSizePerPageChange: PropTypes__default["default"].func.isRequired,
  bootstrap4: PropTypes__default["default"].bool
};
SizePerPageOption.defaultProps = {
  bootstrap4: false
};
var SizePerPageOption$1 = SizePerPageOption;

const sizePerPageDefaultClass = 'react-bs-table-sizePerPage-dropdown';
const SizePerPageDropDown = props => {
  const {
    open,
    tableId,
    hidden,
    onClick,
    onBlur,
    options,
    className,
    variation,
    bootstrap4,
    btnContextual,
    optionRenderer,
    currSizePerPage,
    onSizePerPageChange
  } = props;
  const dropDownStyle = {
    visibility: hidden ? 'hidden' : 'visible'
  };
  const openClass = open ? 'open show' : '';
  const dropdownClasses = cs__default["default"](openClass, sizePerPageDefaultClass, variation, className);
  const id = tableId ? `${tableId}-pageDropDown` : 'pageDropDown';
  return /*#__PURE__*/React__default["default"].createElement("span", {
    style: dropDownStyle,
    className: dropdownClasses
  }, /*#__PURE__*/React__default["default"].createElement("button", {
    id: id,
    type: "button",
    className: `btn ${btnContextual} dropdown-toggle`,
    "data-toggle": "dropdown",
    "aria-expanded": open,
    onClick: onClick,
    onBlur: onBlur
  }, currSizePerPage, ' ', bootstrap4 ? null : /*#__PURE__*/React__default["default"].createElement("span", null, /*#__PURE__*/React__default["default"].createElement("span", {
    className: "caret"
  }))), /*#__PURE__*/React__default["default"].createElement("ul", {
    className: `dropdown-menu ${openClass}`,
    role: "menu",
    "aria-labelledby": id
  }, options.map(option => {
    if (optionRenderer) {
      return optionRenderer(_objectSpread2(_objectSpread2({}, option), {}, {
        onSizePerPageChange
      }));
    }
    return /*#__PURE__*/React__default["default"].createElement(SizePerPageOption$1, _extends({}, option, {
      key: option.text,
      bootstrap4: bootstrap4,
      onSizePerPageChange: onSizePerPageChange
    }));
  })));
};
SizePerPageDropDown.propTypes = {
  currSizePerPage: PropTypes__default["default"].string.isRequired,
  options: PropTypes__default["default"].array.isRequired,
  onClick: PropTypes__default["default"].func.isRequired,
  onBlur: PropTypes__default["default"].func.isRequired,
  onSizePerPageChange: PropTypes__default["default"].func.isRequired,
  bootstrap4: PropTypes__default["default"].bool,
  tableId: PropTypes__default["default"].string,
  open: PropTypes__default["default"].bool,
  hidden: PropTypes__default["default"].bool,
  btnContextual: PropTypes__default["default"].string,
  variation: PropTypes__default["default"].oneOf(['dropdown', 'dropup']),
  className: PropTypes__default["default"].string,
  optionRenderer: PropTypes__default["default"].func
};
SizePerPageDropDown.defaultProps = {
  open: false,
  hidden: false,
  btnContextual: 'btn-default btn-secondary',
  variation: 'dropdown',
  className: '',
  optionRenderer: null,
  bootstrap4: false,
  tableId: null
};
var SizePerPageDropdown = SizePerPageDropDown;

const sizePerPageDropdownAdapter = WrappedComponent => class SizePerPageDropdownAdapter extends pageResolver(React.Component) {
  constructor(...args) {
    super(...args);
    this.state = {
      dropdownOpen: false
    };
    this.toggleDropDown = () => {
      this.setState(({
        dropdownOpen
      }) => ({
        dropdownOpen: !dropdownOpen
      }));
    };
    this.closeDropDown = () => {
      this.setState({
        dropdownOpen: false
      });
    };
    this.handleChangeSizePerPage = sizePerPage => {
      this.props.onSizePerPageChange(sizePerPage);
      this.closeDropDown();
    };
  }
  render() {
    const {
      tableId,
      bootstrap4,
      sizePerPageList,
      currSizePerPage,
      hideSizePerPage,
      sizePerPageRenderer,
      sizePerPageOptionRenderer
    } = this.props;
    const {
      dropdownOpen: open
    } = this.state;
    if (sizePerPageList.length > 1 && !hideSizePerPage) {
      if (sizePerPageRenderer) {
        return sizePerPageRenderer({
          options: this.calculateSizePerPageStatus(),
          currSizePerPage: `${currSizePerPage}`,
          onSizePerPageChange: this.handleChangeSizePerPage
        });
      }
      return /*#__PURE__*/React__default["default"].createElement(WrappedComponent, _extends({}, this.props, {
        currSizePerPage: `${currSizePerPage}`,
        options: this.calculateSizePerPageStatus(),
        optionRenderer: sizePerPageOptionRenderer,
        onSizePerPageChange: this.handleChangeSizePerPage,
        onClick: this.toggleDropDown,
        onBlur: this.closeDropDown,
        open: open,
        tableId: tableId,
        bootstrap4: bootstrap4
      }));
    }
    return null;
  }
};
const SizePerPageDropdownWithAdapter = sizePerPageDropdownAdapter(SizePerPageDropdown);
var sizePerPageDropdownAdapter$1 = sizePerPageDropdownAdapter;

/* eslint-disable jsx-a11y/anchor-is-valid */
class PageButton extends React.Component {
  constructor(...args) {
    super(...args);
    this.handleClick = e => {
      const {
        onPageChange,
        page
      } = this.props;
      e.preventDefault();
      onPageChange(page);
    };
  }
  render() {
    const {
      page,
      title,
      active,
      disabled,
      className
    } = this.props;
    const classes = cs__default["default"]({
      active,
      disabled,
      'page-item': true
    }, className);
    return /*#__PURE__*/React__default["default"].createElement("li", {
      className: classes,
      title: title
    }, /*#__PURE__*/React__default["default"].createElement("a", {
      href: "#",
      onClick: this.handleClick,
      className: "page-link"
    }, page));
  }
}
PageButton.propTypes = {
  onPageChange: PropTypes__default["default"].func.isRequired,
  page: PropTypes__default["default"].oneOfType([PropTypes__default["default"].node, PropTypes__default["default"].number, PropTypes__default["default"].string]).isRequired,
  active: PropTypes__default["default"].bool.isRequired,
  disabled: PropTypes__default["default"].bool.isRequired,
  className: PropTypes__default["default"].string,
  title: PropTypes__default["default"].string
};
var PageButton$1 = PageButton;

const PaginatonList = ({
  pages,
  pageButtonRenderer,
  onPageChange
}) => /*#__PURE__*/React__default["default"].createElement("ul", {
  className: "pagination react-bootstrap-table-page-btns-ul"
}, pages.map(pageProps => {
  if (pageButtonRenderer) {
    return pageButtonRenderer(_objectSpread2(_objectSpread2({}, pageProps), {}, {
      onPageChange
    }));
  }
  return /*#__PURE__*/React__default["default"].createElement(PageButton$1, _extends({
    key: pageProps.page
  }, pageProps, {
    onPageChange: onPageChange
  }));
}));
PaginatonList.propTypes = {
  pages: PropTypes__default["default"].arrayOf(PropTypes__default["default"].shape({
    page: PropTypes__default["default"].oneOfType([PropTypes__default["default"].node, PropTypes__default["default"].number, PropTypes__default["default"].string]),
    active: PropTypes__default["default"].bool,
    disable: PropTypes__default["default"].bool,
    title: PropTypes__default["default"].string
  })).isRequired,
  onPageChange: PropTypes__default["default"].func.isRequired,
  pageButtonRenderer: PropTypes__default["default"].func
};
PaginatonList.defaultProps = {
  pageButtonRenderer: null
};
var PaginationList = PaginatonList;

/* eslint react/prop-types: 0 */

// eslint-disable-next-line max-len
const paginationListAdapter = WrappedComponent => class PaginationListAdapter extends pageResolver(React.Component) {
  render() {
    const {
      lastPage,
      totalPages,
      pageButtonRenderer,
      onPageChange,
      disablePageTitle,
      hidePageListOnlyOnePage
    } = this.props;
    const pages = this.calculatePageStatus(this.calculatePages(totalPages, lastPage), lastPage, disablePageTitle);
    if (totalPages === 1 && hidePageListOnlyOnePage) {
      return null;
    }
    return /*#__PURE__*/React__default["default"].createElement(WrappedComponent, {
      pageButtonRenderer: pageButtonRenderer,
      onPageChange: onPageChange,
      pages: pages
    });
  }
};
const PaginationListWithAdapter = paginationListAdapter(PaginationList);
var paginationListAdapter$1 = paginationListAdapter;

const PaginationTotal = props => {
  const {
    paginationTotalRenderer,
    from,
    to,
    dataSize
  } = props;
  if (paginationTotalRenderer) {
    return paginationTotalRenderer(from, to, dataSize);
  }
  return /*#__PURE__*/React__default["default"].createElement("span", {
    className: "react-bootstrap-table-pagination-total"
  }, "\xA0Showing rows", ' ', from, ' ', "to\xA0", to, ' ', "of\xA0", dataSize);
};
PaginationTotal.propTypes = {
  from: PropTypes__default["default"].number.isRequired,
  to: PropTypes__default["default"].number.isRequired,
  dataSize: PropTypes__default["default"].number.isRequired,
  paginationTotalRenderer: PropTypes__default["default"].func
};
PaginationTotal.defaultProps = {
  paginationTotalRenderer: undefined
};
var PaginationTotal$1 = PaginationTotal;

/* eslint react/prop-types: 0 */

// eslint-disable-next-line max-len
const paginationTotalAdapter = WrappedComponent => class PaginationTotalAdapter extends pageResolver(React.Component) {
  render() {
    const [from, to] = this.calculateFromTo();
    return /*#__PURE__*/React__default["default"].createElement(WrappedComponent, {
      from: from,
      to: to,
      dataSize: this.props.dataSize,
      paginationTotalRenderer: this.props.paginationTotalRenderer
    });
  }
};
const PaginationTotalWithAdapter = paginationTotalAdapter(PaginationTotal$1);
var paginationTotalAdapter$1 = paginationTotalAdapter;

const _excluded$2 = ["tableId", "currPage", "pageStartIndex", "showTotal", "dataSize", "pageListRenderer", "pageButtonRenderer", "paginationTotalRenderer", "hidePageListOnlyOnePage", "totalPages", "lastPage", "onPageChange", "sizePerPageList", "currSizePerPage", "hideSizePerPage", "sizePerPageRenderer", "sizePerPageOptionRenderer", "onSizePerPageChange", "bootstrap4", "paginationClassName", "paginationStyle"];
class Pagination extends pageResolver(React.Component) {
  render() {
    const _this$props = this.props,
      {
        tableId,
        currPage,
        pageStartIndex,
        showTotal,
        dataSize,
        pageListRenderer,
        pageButtonRenderer,
        paginationTotalRenderer,
        hidePageListOnlyOnePage,
        totalPages,
        lastPage,
        onPageChange,
        sizePerPageList,
        currSizePerPage,
        hideSizePerPage,
        sizePerPageRenderer,
        sizePerPageOptionRenderer,
        onSizePerPageChange,
        bootstrap4,
        paginationClassName = '',
        paginationStyle = {}
      } = _this$props,
      rest = _objectWithoutProperties(_this$props, _excluded$2);
    const pages = this.calculatePageStatus(this.calculatePages(totalPages, lastPage), lastPage);
    const pageListClass = cs__default["default"]('react-bootstrap-table-pagination-list', 'col-md-6 col-xs-6 col-sm-6 col-lg-6', {
      'react-bootstrap-table-pagination-list-hidden': hidePageListOnlyOnePage && totalPages === 1
    });
    return /*#__PURE__*/React__default["default"].createElement("div", {
      className: cs__default["default"]('row react-bootstrap-table-pagination', paginationClassName),
      style: paginationStyle
    }, /*#__PURE__*/React__default["default"].createElement("div", {
      className: "col-md-6 col-xs-6 col-sm-6 col-lg-6"
    }, /*#__PURE__*/React__default["default"].createElement(SizePerPageDropdownWithAdapter, _extends({}, rest, {
      bootstrap4: bootstrap4,
      tableId: tableId,
      sizePerPageList: sizePerPageList,
      currSizePerPage: currSizePerPage,
      hideSizePerPage: hideSizePerPage,
      sizePerPageRenderer: sizePerPageRenderer,
      sizePerPageOptionRenderer: sizePerPageOptionRenderer,
      onSizePerPageChange: onSizePerPageChange
    })), showTotal ? /*#__PURE__*/React__default["default"].createElement(PaginationTotalWithAdapter, _extends({}, rest, {
      currPage: currPage,
      currSizePerPage: currSizePerPage,
      pageStartIndex: pageStartIndex,
      dataSize: dataSize,
      paginationTotalRenderer: paginationTotalRenderer
    })) : null), pageListRenderer ? pageListRenderer({
      pages,
      onPageChange
    }) : /*#__PURE__*/React__default["default"].createElement("div", {
      className: pageListClass
    }, /*#__PURE__*/React__default["default"].createElement(PaginationListWithAdapter, _extends({}, rest, {
      currPage: currPage,
      currSizePerPage: currSizePerPage,
      pageStartIndex: pageStartIndex,
      lastPage: lastPage,
      totalPages: totalPages,
      pageButtonRenderer: pageButtonRenderer,
      onPageChange: onPageChange
    }))));
  }
}
Pagination.propTypes = {
  dataSize: PropTypes__default["default"].number.isRequired,
  sizePerPageList: PropTypes__default["default"].array.isRequired,
  currPage: PropTypes__default["default"].number.isRequired,
  currSizePerPage: PropTypes__default["default"].number.isRequired,
  onPageChange: PropTypes__default["default"].func.isRequired,
  onSizePerPageChange: PropTypes__default["default"].func.isRequired,
  disablePageTitle: PropTypes__default["default"].bool,
  pageStartIndex: PropTypes__default["default"].number,
  paginationSize: PropTypes__default["default"].number,
  showTotal: PropTypes__default["default"].bool,
  pageListRenderer: PropTypes__default["default"].func,
  pageButtonRenderer: PropTypes__default["default"].func,
  sizePerPageRenderer: PropTypes__default["default"].func,
  paginationTotalRenderer: PropTypes__default["default"].func,
  sizePerPageOptionRenderer: PropTypes__default["default"].func,
  firstPageText: PropTypes__default["default"].oneOfType([PropTypes__default["default"].string, PropTypes__default["default"].node]),
  prePageText: PropTypes__default["default"].oneOfType([PropTypes__default["default"].string, PropTypes__default["default"].node]),
  nextPageText: PropTypes__default["default"].oneOfType([PropTypes__default["default"].string, PropTypes__default["default"].node]),
  lastPageText: PropTypes__default["default"].oneOfType([PropTypes__default["default"].string, PropTypes__default["default"].node]),
  nextPageTitle: PropTypes__default["default"].string,
  prePageTitle: PropTypes__default["default"].string,
  firstPageTitle: PropTypes__default["default"].string,
  lastPageTitle: PropTypes__default["default"].string,
  withFirstAndLast: PropTypes__default["default"].bool,
  alwaysShowAllBtns: PropTypes__default["default"].bool,
  hideSizePerPage: PropTypes__default["default"].bool,
  hidePageListOnlyOnePage: PropTypes__default["default"].bool,
  bootstrap4: PropTypes__default["default"].bool
};
Pagination.defaultProps = {
  disablePageTitle: false,
  bootstrap4: false,
  pageStartIndex: Const.PAGE_START_INDEX,
  paginationSize: Const.PAGINATION_SIZE,
  withFirstAndLast: Const.With_FIRST_AND_LAST,
  alwaysShowAllBtns: Const.SHOW_ALL_PAGE_BTNS,
  showTotal: Const.SHOW_TOTAL,
  pageListRenderer: null,
  pageButtonRenderer: null,
  sizePerPageRenderer: null,
  paginationTotalRenderer: Const.PAGINATION_TOTAL,
  sizePerPageOptionRenderer: null,
  firstPageText: Const.FIRST_PAGE_TEXT,
  prePageText: Const.PRE_PAGE_TEXT,
  nextPageText: Const.NEXT_PAGE_TEXT,
  lastPageText: Const.LAST_PAGE_TEXT,
  sizePerPageList: Const.SIZE_PER_PAGE_LIST,
  nextPageTitle: Const.NEXT_PAGE_TITLE,
  prePageTitle: Const.PRE_PAGE_TITLE,
  firstPageTitle: Const.FIRST_PAGE_TITLE,
  lastPageTitle: Const.LAST_PAGE_TITLE,
  hideSizePerPage: Const.HIDE_SIZE_PER_PAGE,
  hidePageListOnlyOnePage: Const.HIDE_PAGE_LIST_ONLY_ONE_PAGE
};
var Pagination$1 = paginationHandler(Pagination);

const _excluded$1 = ["page", "sizePerPage", "dataSize"];
const {
  Provider: Provider$1
} = createBaseContext();
const PaginationDataContext = /*#__PURE__*/React__default["default"].createContext();
class PaginationDataProvider extends Provider$1 {
  constructor(...args) {
    super(...args);
    this.isRemotePagination = () => this.props.isRemotePagination();
    this.renderDefaultPagination = () => {
      if (!this.props.pagination.options.custom) {
        const _this$getPaginationPr = this.getPaginationProps(),
          {
            page: currPage,
            sizePerPage: currSizePerPage,
            dataSize
          } = _this$getPaginationPr,
          rest = _objectWithoutProperties(_this$getPaginationPr, _excluded$1);
        return /*#__PURE__*/React__default["default"].createElement(Pagination$1, _extends({}, rest, {
          key: "pagination",
          dataSize: dataSize || this.props.data.length,
          currPage: currPage,
          currSizePerPage: currSizePerPage
        }));
      }
      return null;
    };
  }
  // componentDidUpdate(prevProps) {
  //   super.componentDidUpdate(this.props);
  //   const { currSizePerPage } = this;
  //   const { custom, onPageChange } = this.props.pagination.options;

  //   const pageStartIndex = typeof this.props.pagination.options.pageStartIndex !== 'undefined'
  //     ? this.props.pagination.options.pageStartIndex : Const.PAGE_START_INDEX;

  //   // user should align the page when the page is not fit to the data size when remote enable
  //   if (!this.isRemotePagination() && !custom) {
  //     const newPage = alignPage(
  //       this.props.data.length,
  //       prevProps.data.length,
  //       this.currPage,
  //       currSizePerPage,
  //       pageStartIndex
  //     );

  //     if (this.currPage !== newPage) {
  //       if (onPageChange) {
  //         onPageChange(newPage, currSizePerPage);
  //       }
  //       this.currPage = newPage;
  //     }
  //   }
  //   if (this.props.onDataSizeChange && this.props.data.length !== prevProps.data.length) {
  //     this.props.onDataSizeChange({ dataSize: this.props.data.length });
  //   }
  // }

  // eslint-disable-next-line camelcase
  UNSAFE_componentWillReceiveProps(nextProps) {
    super.UNSAFE_componentWillReceiveProps(nextProps);
    const {
      currSizePerPage
    } = this;
    const {
      custom,
      onPageChange
    } = nextProps.pagination.options;
    const pageStartIndex = typeof nextProps.pagination.options.pageStartIndex !== 'undefined' ? nextProps.pagination.options.pageStartIndex : Const.PAGE_START_INDEX;

    // user should align the page when the page is not fit to the data size when remote enable
    if (!this.isRemotePagination() && !custom) {
      const newPage = alignPage(nextProps.data.length, this.props.data.length, this.currPage, currSizePerPage, pageStartIndex);
      if (this.currPage !== newPage) {
        if (onPageChange) {
          onPageChange(newPage, currSizePerPage);
        }
        this.currPage = newPage;
      }
    }
    if (nextProps.onDataSizeChange && nextProps.data.length !== this.props.data.length) {
      nextProps.onDataSizeChange({
        dataSize: nextProps.data.length
      });
    }
  }
  render() {
    let {
      data
    } = this.props;
    const {
      pagination: {
        options
      }
    } = this.props;
    const {
      currPage,
      currSizePerPage
    } = this;
    const pageStartIndex = typeof options.pageStartIndex === 'undefined' ? Const.PAGE_START_INDEX : options.pageStartIndex;
    data = this.isRemotePagination() ? data : getByCurrPage(data, currPage, currSizePerPage, pageStartIndex);
    return /*#__PURE__*/React__default["default"].createElement(PaginationDataContext.Provider, {
      value: {
        data,
        setPaginationRemoteEmitter: this.setPaginationRemoteEmitter
      }
    }, this.props.children, this.renderDefaultPagination());
  }
}
PaginationDataProvider.propTypes = {
  data: PropTypes__default["default"].array.isRequired,
  remoteEmitter: PropTypes__default["default"].object.isRequired,
  isRemotePagination: PropTypes__default["default"].func.isRequired
};
var createDataContext = (() => ({
  Provider: PaginationDataProvider,
  Consumer: PaginationDataContext.Consumer
}));

const _excluded = ["page", "sizePerPage"];
var standaloneAdapter = (WrappedComponent => _ref => {
  let {
      page,
      sizePerPage
    } = _ref,
    rest = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/React__default["default"].createElement(WrappedComponent, _extends({}, rest, {
    currPage: page,
    currSizePerPage: sizePerPage
  }));
});

/* eslint-disable react/jsx-props-no-spreading */
const PaginationListStandalone = props => /*#__PURE__*/React__default["default"].createElement(PaginationList, props);
var paginationListStandalone = standaloneAdapter(paginationHandler(paginationListAdapter$1(PaginationListStandalone)));

/* eslint-disable react/jsx-props-no-spreading */
const SizePerPageDropdownStandalone = props => /*#__PURE__*/React__default["default"].createElement(SizePerPageDropdown, props);
var sizePerPageDropdownStandalone = standaloneAdapter(paginationHandler(sizePerPageDropdownAdapter$1(SizePerPageDropdownStandalone)));

/* eslint-disable react/jsx-props-no-spreading */
const PaginationTotalStandalone = props => /*#__PURE__*/React__default["default"].createElement(PaginationTotal$1, props);
var paginationTotalStandalone = standaloneAdapter(paginationTotalAdapter$1(PaginationTotalStandalone));

/* eslint-disable react/jsx-props-no-spreading */
var index = ((options = {}) => ({
  createContext: createDataContext,
  options
}));
const {
  Provider,
  Consumer
} = createBaseContext();
const CustomizableProvider = props => /*#__PURE__*/React__default["default"].createElement(Provider, props, /*#__PURE__*/React__default["default"].createElement(Consumer, null, paginationProps => props.children(paginationProps)));
CustomizableProvider.propTypes = {
  children: PropTypes__default["default"].func.isRequired
};
const PaginationProvider = CustomizableProvider;

exports.PaginationListStandalone = paginationListStandalone;
exports.PaginationProvider = PaginationProvider;
exports.PaginationTotalStandalone = paginationTotalStandalone;
exports.SizePerPageDropdownStandalone = sizePerPageDropdownStandalone;
exports["default"] = index;
